#!/usr/bin/perl -sw

eval "exec /usr/local/bin/perl -s $0"
  if $running_under_some_shell;

# @(#)@ process	1.23 - process.pl
#
# This program processes mail messages, and enqueues requests for
# the mail server.
#
# Arguments used when running with "perl -s"
#
$debug=0 unless $debug;
$nobatch=0 unless $nobatch;
#

################ configuration section ################
#
# where the progams and files reside
#
$lib = "/usr/lib/mserv";
#
# where to find the files
#
# $lib/libs.pl should contain something like
# @libdirs = ("/u2/goodies/", "/u1/jv/perl3.0gamma/");
#
do "$lib/libs.pl";
#
# sendmail -t
#
$sendmail = "/usr/lib/smail/sendmail-t";
#
# mail server user id
# set to "" if you don't want him to receive a Bcc of each request.
#
$mserv = "mserv";
#
################ end of configuration section ################

$errflag = 0;
$didhelp = 0;

format work_header =
  request                format (uncoded size)  encoding  limit  remarks
  ---------------------  ---------------------  --------  -----  -------
.
format work_list =
  @<<<<<<<<<<<<<<<<<<<<< @<<<<<<<<<<<<<<<<<<<<  @<<<<<<<  @>>>>  @<<<<<<<<<<<<<<<<<<<<<<<<<<<
  $request,             $format,               $coding,  $K,    $remarks
.

do "$lib/rfc822.pl";
do "stat.pl";
$S_IFREG = 0100000;	# regular file

$tmpfile = "/tmp/mserv$$";
open (stdout, ">" . $tmpfile) unless $debug;

print "Multihouse Research Mail Server 1.23\n";

do rfc822_start_read ("-") || die ("cannot read input\n");

# flush "From_ line...
if ( $rfc822_line_in_cache =~ /^From / ) {
  $rfc822_line_in_cache = "";
}

print "Processing mail headers ...\n";

$h_from = "";
$h_reply = "";
$h_subj = "";

while ( do rfc822_not_eof ()) {
  $res = do rfc822_read_header (0);
  last if $res != $rfc822_valid_header;
  $rfc822_header =~ tr/[A-Z]/[a-z]/;
  $h_from = $rfc822_contents if $rfc822_header eq "from";
  $h_subject = $rfc822_contents if $rfc822_header eq "subject";
  $h_reply = $rfc822_contents if $rfc822_header eq "reply-to";
}


$path = $h_from if $h_from ne "";
$path = $h_reply if $h_reply ne "";
print "Return address: \"$path\"\n";

print "\nProcessing message contents...\n\n";

# set defaults
$encode = "uuencode";
$def_limit = $limit = 64*1024;
@work = ();

# formats we can handle
$fmt{".Z"  } = "Compressed";
$fmt{".TZ" } = "Compressed Tar";
$fmt{".zoo"} = "Zoo";
$fmt{".tar"} = "Tar";
$fmt{".shar"} = "Shell Archive";

$commands = 0;
while ( do rfc822_not_eof ()) {
  $res = do rfc822_read_header (1);
  next if $res != $rfc822_data_line;

  $commands++;
  print "Command: $rfc822_line\n";
  @cmd = split (/[\t ,]+/, $rfc822_line);
  shift (@cmd) if $cmd[0] eq "";	# skip leading null arg, if any

  # get command verb, shifting leading "set" verb

  do {
    $cmd = shift (@cmd);
    last unless $cmd;
    $cmd  =~ tr/[a-z]/[A-Z]/;
  } while ( $cmd eq "SET" );

  if (( $cmd eq "EXIT" ) | ( $cmd eq "END" )) {
    print "=> Okay\n";
    last;
  }

  ################ path <path> ################

  if ( $cmd eq "PATH" ) {

    if ( $#cmd == 0 ) {
      $path = $cmd[0];
      print "=> Return address: \"$path\"\n";
    }
    else {
      do errmsg ("PATH takes one argument");
    }
    print "\n";
  }

  ################ limit [ <number>[K] ] ################

  elsif ( $cmd eq "LIMIT" ) {

    if ( $#cmd < 0 ) {
      $limit = $def_limit;
      print "=> Limit = $limit\n";
    }
    elsif ( $#cmd == 0 ) {
      $try = $cmd[0];
      $new = -1;
      if ( $try =~ /^\d+$/ ) {
	$new = 0+$try;
      }
      elsif ( $try =~ /^(\d+)K$/i ) {
	$new = $1 * 1024;
      }

      if ( $new < 0 ) {
	do errmsg ("LIMIT takes one optional numeric argument");
      }
      elsif ( ($new < 1024) | ($new > 256*1024) ) {
	do errmsg ("LIMIT must be between 1K and 256K");
      }
      else {
	$limit = $new;
	print "=> Limit = $limit\n";
      }
    }
    else {
      do errmsg ("LIMIT takes one optional numeric argument");
    }
    print "\n";
  }

  ################ uuencode ################

  elsif ( $cmd eq "UUENCODE" || $cmd eq "UUDECODE" ) {
    if ( $#cmd < 0 ) {
      $encode = "uuencode";
      print "=> Encoding = $encode\n";
    }
    else {
      do errmsg ("UUENCODE does not take any arguments");
    }
    print "\n";
  }

  ################ btoa ################

  elsif ( $cmd eq "BTOA" || $cmd eq "ATOB") {
    if ( $#cmd < 0 ) {
      $encode = "btoa";
      print "=> Encoding = $encode\n";
    }
    else {
      do errmsg ("BTOA does not take any arguments");
    }
    print "\n";
  }

  ################ send <item> [ <item>...] ################

  elsif ( $cmd eq "SEND" ) {
    if ( $#cmd >= 0 ) {
      do {
	$item = shift (@cmd);
	push (@work, "$limit $encode $item");
	print "=> Send: $item\n";
      } while ( $#cmd >= 0 );
    }
    else {
      do errmsg ("SEND commands needs arguments");
    }
    print "\n";
  }

  ################ resend <item> <number> [ <number>...] ################

  elsif ( $cmd eq "RESEND" ) {
    if ( $#cmd >= 1 ) {
      $request = shift (@cmd);
      @plist = ();
      while ( $#cmd >= 0 ) {
	$num = shift (@cmd);
	if ( $num =~ /^\d+$/ ) {
	  push (@plist, 0+$num);
	}
	else {
	  do errmsg ("RESEND commands needs an item and a list of numbers");
	  last;
	}
      }
      push (@work, "$limit $encode $request " . join (",", @plist));
      print "=> Resend: $request, part",
	    ($#plist > 0) ? "s " : " ", join (",", @plist), "\n";
    }
    else {
      do errmsg ("RESEND commands needs an item and a list of numbers");
    }
    print "\n";
  }

#   ################ index ################
# 
#   elsif ( $cmd eq "INDEX" ) {
#     if ( $#cmd < 0 ) {
#       $item = "INDEX";
#       push (@work, "$limit $encode $item");
#       print "=> Send: $item\n";
#     }
#     else {
#       do errmsg ("INDEX command does not take any arguments");
#     }
#     print "\n";
#   }

  ################ help ################

  elsif ( $cmd eq "HELP" ) {
    if ( $#cmd < 0 ) {
      do help ();
    }
    else {
      do errmsg ("HELP does not take any arguments");
    }
    print "\n";
  }

  ################ test ################

  elsif ( $cmd eq "TEST" ) {
    if ( $#cmd < 0 ) {
      $nobatch = 1;
      print "=> Okay\n";
    }
    else {
      do errmsg ("Command $cmd unknown");
    }
    print "\n";
  }

  ################ UNKNOWN ################

  else {
    do errmsg ("Command $cmd unknown");
    print "\n";
  }

}

print "\nYour message has been processed.\n";

if ( $commands == 0 ) {

  print "No commands were found.\n";
  do help ();

}
elsif ( $errflag ) {

  print "Number of errors detected = $errflag.\n";
  print "NO WORK WILL BE DONE.\n";
  do help () unless $didhelp;

}
else {

  $^ = "work_header";
  $~ = "work_list";
  $entries = 0;

  if ( $#work >= 0 ) {
    print "The following request", 
	($#work > 0 ) ? "s have" : " has",
	" been queued:\n\n";
  }

  while ( $#work >= 0 ) {

    @tmp = split (/ /, shift (@work));
    $K = int((1023+$tmp[0])/1024) . "K";
    $coding = $tmp[1];
    $request = $tmp[2];
    if ( $#tmp > 2 ) {
      $plist = $tmp[3];
    } else { $plist = ""; }

    $format = "Unknown";
    $remarks = "";

    # pass thru the libdirs to find the requested file
    findfile:
      for (@libs = @libdirs; $#libs >= 0, $libdir = shift (@libs); )  {

      print "using lib: $libdir\n" if $debug;

      $st_size = 0;
      $the_file = $libdir . $request;

      # prevent security leak
      last findfile if index ($the_file, "/../") >= 0;

      # first, try the filename "as is"
      if ( do Stat ($the_file) && ($st_mode & $S_IFREG) ) {

	# found it - assume text file
	$format = "Plain";

	# find out if one of the format extensions matches the filename
	# note: cannot use "foreach" in perl2
	@k = keys (fmt);
	while ( $#k >= 0 ) {
	  $f = shift (@k);
	  if ( $the_file =~ /$f$/ ) {
	    # it does - adjust format and exit the search
	    $format = $fmt{$f};
	    last findfile;
	  }
	}
	# no match on extension, oh well..
	if ( ($request eq "HELP") | ($request eq "INDEX") ) {
	  $coding = "plain";
	  $K = "";
	}
	last findfile;
      }

      else {

	# append each of the known extensions until a file is found
	# do not use "foreach" here either
	@k = keys (fmt);
	while ( $#k >= 0 ) {
	  $f = shift (@k);
	  if ( do Stat ($the_file . $f) ) {
	    # we have one.
	    # adjust the format, request name, and exit the search
	    $format = $fmt{$f};
	    $request .= $f;
	    $the_file .= $f;
	    last findfile;
	  }
	}
      }
    }

    # have we found something?
    if ( $format eq "Unknown" ) {

      $coding = "";
      $K = "";
      $remarks = "Request skipped";

    }
    else {

      print "File: $the_file\n" if $debug;

      # send .shar files with plain format
      $coding = "plain" if $format eq "Shell Archive";

      $format .= " (" . int(($st_size+1023)/1024) . "K)";
      if ( $plist ) {
        $remarks = "Part";
	$remarks .= "s" if index ($plist, ",") >= 0;
	$remarks .= " $plist only";
      }

      # put the request in the batch queue
      if ( $nobatch ) {
	$entries++;
      }
      else {
	if (open (batch, "|batch") ) {
	  print batch "nice $lib/dorequest \"$path\" \"$the_file\" $coding ",
		      $tmp[0], " ", $plist, "\n";
	  close (batch);
	  if ( $? == 0 ) {
	    $entries++;
	  }
	  else {
	    $remarks = "Queue error";
	  }
	}
	else {
	  $remarks = "Cannot queue";
	}
      }
    }

    # put out the report line
    write;

    # end of pass thru @work
  }

  if ( $entries > 0 ) {
    if ( $entries > 1 ) {
      print "\nThese requests";
    } else {
      print "\nThis request";
    }
    print " will be sent to you as soon as the load of\n";
    print "the server system permits.\n";
  }
}

print "\nServer hints:\n";
print " - \"send unpack.pl\" will send you a perl script to unpack multi-part\n" .
      "   transfers.\n";
print " - \"send btoa\" will yield a \".shar\"-file with the btoa/atob programs.\n";
print " - \"send uudecode\" will yield a \".shar\" with uudecode/uuencode.\n";
print " - \"send compress\" will yield a \".shar\" with compress/uncompress.\n";
print "   The above \".shar\"-files are sent unencoded, of course.\n";
print " - \"send compress.tar\" will yield a tar archive with compress, uncompress,\n";
print "   uudecode, uuencode, btoa, atob, tarmail and untarmail.\n";
print " - \"send HELP\" will yield a document with more info on how to use\n" .
      "   the server.\n" unless $didhelp;
print "\nMail Server finished.\n";
close (stdout);

open (message, $tmpfile);
unlink $tmpfile;

if ( $debug ) {
  open (mailer, ">&stderr");
}
else {
  open (mailer, "|" . $sendmail );
}


print mailer "To: $path\n";
print mailer "Subject: Your request\n";
print mailer "Bcc: $mserv\n" if $mserv;
print mailer "\n";
while ( <message> ) {
  print mailer $_;
}
close (mailer);
close (message);
unlink $tmpfile;

sub errmsg {
  local ($msg) = shift (@_);
  print ">>>>>>>> $msg\n";
  $errflag++;
}

sub help {

  @help_text = (
    "PATH <path>",
    "    Specify return path. Use this if you are not sure that",
    "    your mail system generates correct return addresses.",
    "LIMIT <number>",
    "    Maximum number of bytes to be sent per mail transfer.",
    "    Default is 64K bytes.",
    "    The limit applies to subsequent \"send\" commands.",
    "UUENCODE",
    "BTOA",
    "    Specify encoding to be used. Default is UUENCODE.",
    "    The encoding applies to subsequent \"send\" commands.",
    "    Use \"send btoa\" to obtain the btoa/atob support programs.",
    "SEND <item> [<item>...]",
    "    Specify the items to be sent.",
    "    Use \"send INDEX\" for a list of items.",
    "RESEND <item> <part> [<part>...]",
    "    Re-sends the indicated <parts> from the specified <item>.",
    "    The encoding and limit must be identical to those used in the",
    "    original request.",
    "HELP",
    "    This message.",
    "    Use \"send HELP\" for a detailed description on how to use",
    "    the archive server.",
    "END",
    "EXIT",
    "    Terminate command processing. The remainder of",
    "    the input will be ignored.",
    "",
    "Case is insignificant in the command verbs, but it is",
    "significant in the <path> and <item> specifications.",
    "" );

  print "\nValid server commands are:\n\n";

  foreach $line ( @help_text ) {
    print $line, "\n";
  }
  print "\n";
  $didhelp = 1;

}
